ExpressObject subclass: #ExpressCheck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Ext-ExpressSend-Ex'!
ExpressCheck comment:
'Class ExpressCheck is a simple example to show how express messages may interrupt standard message computation.
Note that because method Express does a nonResume, if a normal message (normal) was interrupted, it is aborted.'!


!ExpressCheck methodsFor: 'script'!

Express: delay
	"This is an express mode message."

	Transcript show: 'start express'; cr.
	(Delay forMilliseconds: delay) wait.
	Transcript show: 'express stop'; cr!

ExpressNonResume: delay
	"This is an express mode message."

	Transcript show: 'start express'; cr.
	(Delay forMilliseconds: delay) wait.
	Transcript show: 'nonResume '; cr.
	self nonResume.
	Transcript show: 'express stop'; cr!

normal: delay

	Transcript show: 'start normal'; cr.
	(Delay forMilliseconds: delay) wait.
	Transcript show: 'normal stop'; cr!

normalAtomic: delay

	self expressAtomic:
		[Transcript show: 'atomic '.
		self normal: delay]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ExpressCheck class
	instanceVariableNames: ''!


!ExpressCheck class methodsFor: 'example'!

example
	"self example"

	| expressActiveObject |
	expressActiveObject := self new active.
	expressActiveObject normal: 100; ExpressNonResume: 100; normalAtomic: 100; normal: 100.
	(Delay forMilliseconds: 1500) wait.
	expressActiveObject Express: 40! !
